#![feature(str_strip)]
extern crate reqwest;
extern crate tempfile;

use crate::problem1::lib::Problem1;
use crate::problem2::lib::Problem2;
use crate::problem3::lib::Problem3;
use crate::problem4::lib::Problem4;
use crate::problem5::lib::Problem5;
use crate::problem6::lib::Problem6;
use crate::problem7::lib::Problem7;
use crate::problem8::lib::Problem8;
use crate::problem9::lib::Problem9;

mod problem1;
mod problem2;
mod problem3;
mod problem4;
mod problem5;
mod problem6;
mod problem7;
mod problem8;
mod problem9;
mod util;


pub trait Problem {
    // Parses input and generates state
    fn new(input: &String) -> Self;

    // Runs on state
    fn run_part1(&self);
    fn run_part2(&self);
}

fn main() {
    let problem9 = Problem9::new(&util::get_problem(9));
    problem9.run_part1();
    problem9.run_part2();
}
